application:setBackgroundColor(0x323232)

require "ImGui"


local DB = { "apples", "peaches", "bananas", "mangoes"} 

local storage = "PRESS SOMETHING"

function print_r(arr, indentLevel)
    local str = ""
    local indentStr = "#"

    if(indentLevel == nil) then
        print(print_r(arr, 0))
        return
    end

    for i = 0, indentLevel do
        indentStr = indentStr.."\t"
    end

    for index,value in pairs(arr) do
        if type(value) == "table" then
            str = str..indentStr..index..": \n"..print_r(value, (indentLevel + 1))
        else 
            str = str..indentStr..index..": "..value.."\n"
        end
    end
    return str
end


-- mouse_listeners: adds internal mouse event listeners
-- keyboard_listeners: adds internal keyboard event listeners
-- touch_listeners: adds internal touch event listeners
--ImGui.new([font_atlas = nil, mouse_listeners = true, keyboard_listeners = true, touch_listeners = false])

ui = ImGui.new(nil, false, true, false) 
IO = ui:getIO()





	

function onWindowResize(rt)
	local minX, minY, maxX, maxY = application:getLogicalBounds()
	
	local sx = application:getLogicalScaleX()
	local sy = application:getLogicalScaleY()
 
	ui:setScale(1 / sx, 1 / sy)
	-- move UI to top left corner
	ui:setPosition(minX, minY)
	-- resize display area
	IO:setDisplaySize((maxX - minX) * sx, (maxY - minY) * sy)
	
	if rt then
		rt = {
			x  = minX,
			X  = maxX,
			y  = minY,
			Y  = maxY,
			Sx = sx,
			Sy = sy,
			w  = (maxX - minX) * sx,
			h  = (maxY - minY) * sy
		}
		return rt
	end
end

ss = onWindowResize(true)


function DrawWindow(ui)

		ui:setNextWindowSize(ss.w, ss.h)
		ui:setNextWindowPos(ss.x, ss.y)
		window02 = ui:beginWindow(
			"Window02", --title
			nil,  -- no close button
			ImGui.WindowFlags_NoCollapse | ImGui.WindowFlags_NoResize | ImGui.WindowFlags_NoBringToFrontOnFocus | ImGui.WindowFlags_NoMove
			)
			
		ui:text(storage)

		
	local buttons = {}
	--buttons filled with strings from DB
	for i=1, #DB do
	
		buttons[i] = ui:button(DB[i], ss.w/5, ss.h/5)
		
		if (buttons[i]) then print("pressed "..DB[i]) storage = "pressed "..DB[i] 	end
	end

		ui:endWindow()
		

end

local function onDrawGui(e)
	ui:newFrame(e.deltaTime)
	
	DrawWindow(ui)

	
	ui:updateCursor()
	ui:render()
	ui:endFrame()
end


onWindowResize()


local function touch_start(e)
	print("TOUCH BEGIN")
	if e.touch.mouseButton==0 then e.touch.mouseButton=1 end	 
	ui:onTouchBegin(e)
	print_r(e.touch)
	

end

local function touch_end(e)
	if e.touch.mouseButton==0 then e.touch.mouseButton=1 end
	ui:onTouchEnd(e)
	print("TOUCH END")	 
end

local function mouse_down(e)
	print("MOUSE DOWN")
	ui:onMouseDown(e)
end

local function mouse_up(e)
	print("MOUSE UP")
	ui:onMouseUp(e)
end




stage:addEventListener("touchesBegin", function(e)  touch_start(e) end)
stage:addEventListener("touchesEnd", function(e) touch_end(e) end)
stage:addEventListener("mouseDown", function(e) mouse_down(e) end)
stage:addEventListener("mouseUp", function(e) mouse_up(e) end)
stage:addEventListener("enterFrame", onDrawGui)
stage:addEventListener("applicationResize", onWindowResize)


stage:addChild(ui)




